## systemd 240

=== meson_options.txt ===
# -*- mode: meson -*-
# SPDX-License-Identifier: LGPL-2.1+

option('split-usr', type : 'combo', choices : ['auto', 'true', 'false'],
       description : '''/bin, /sbin aren't symlinks into /usr''')
option('split-bin', type : 'combo', choices : ['auto', 'true', 'false'],
       description : '''sbin is not a symlink to bin''')
option('rootlibdir', type : 'string',
       description : '''[/usr]/lib/x86_64-linux-gnu or such''')
option('rootprefix', type : 'string',
       description : '''override the root prefix''')
option('link-udev-shared', type : 'boolean',
       description : 'link systemd-udev and its helpers to libsystemd-shared.so')
option('link-systemctl-shared', type: 'boolean',
       description : 'link systemctl against libsystemd-shared.so')
option('static-libsystemd', type : 'combo',
       choices : ['false', 'true', 'pic', 'no-pic'],
       description : '''install a static library for libsystemd''')
option('static-libudev', type : 'combo',
       choices : ['false', 'true', 'pic', 'no-pic'],
       description : '''install a static library for libudev''')

option('sysvinit-path', type : 'string', value : '/etc/init.d',
       description : 'the directory where the SysV init scripts are located')
option('sysvrcnd-path', type : 'string', value : '/etc/rc.d',
       description : 'the base directory for SysV rcN.d directories')
option('telinit-path', type : 'string', value : '/lib/sysvinit/telinit',
       description : 'path to telinit')
option('rc-local', type : 'string',
       value : '/etc/rc.local')
option('halt-local', type : 'string',
       value : '/usr/sbin/halt.local')

option('quotaon-path', type : 'string', description : 'path to quotaon')
option('quotacheck-path', type : 'string', description : 'path to quotacheck')
option('kmod-path', type : 'string', description : 'path to kmod')
option('kexec-path', type : 'string', description : 'path to kexec')
option('sulogin-path', type : 'string', description : 'path to sulogin')
option('mount-path', type : 'string', description : 'path to mount')
option('umount-path', type : 'string', description : 'path to umount')
option('loadkeys-path', type : 'string', description : 'path to loadkeys')
option('setfont-path', type : 'string', description : 'path to setfont')

option('debug-shell', type : 'string', value : '/bin/sh',
       description : 'path to debug shell binary')
option('debug-tty', type : 'string', value : '/dev/tty9',
       description : 'specify the tty device for debug shell')
option('debug-extra', type : 'array', choices : ['hashmap', 'mmap-cache', 'siphash', 'udev'], value : [],
       description : 'enable extra debugging')
option('memory-accounting-default', type : 'boolean',
       description : 'enable MemoryAccounting= by default')
option('bump-proc-sys-fs-file-max', type : 'boolean',
       description : 'bump /proc/sys/fs/file-max to ULONG_MAX')
option('bump-proc-sys-fs-nr-open', type : 'boolean',
       description : 'bump /proc/sys/fs/nr_open to INT_MAX')
option('valgrind', type : 'boolean', value : false,
       description : 'do extra operations to avoid valgrind warnings')
option('log-trace', type : 'boolean', value : false,
       description : 'enable low level debug logging')

option('utmp', type : 'boolean',
       description : 'support for utmp/wtmp log handling')
option('hibernate', type : 'boolean',
       description : 'support for hibernation')
option('ldconfig', type : 'boolean',
       description : 'support for dynamic linker cache creation')
option('resolve', type : 'boolean',
       description : 'systemd-resolved stack')
option('efi', type : 'boolean',
       description : 'enable systemd-boot and bootctl')
option('tpm', type : 'boolean',
       description : 'TPM should be used to log events and extend the registers')
option('environment-d', type : 'boolean',
       description : 'support for environment.d')
option('binfmt', type : 'boolean',
       description : 'support for custom binary formats')
option('coredump', type : 'boolean',
       description : 'install the coredump handler')
option('logind', type : 'boolean',
       description : 'install the systemd-logind stack')
option('hostnamed', type : 'boolean',
       description : 'install the systemd-hostnamed stack')
option('localed', type : 'boolean',
       description : 'install the systemd-localed stack')
option('machined', type : 'boolean',
       description : 'install the systemd-machined stack')
option('portabled', type : 'boolean',
       description : 'install the systemd-portabled stack')
option('networkd', type : 'boolean',
       description : 'install the systemd-networkd stack')
option('timedated', type : 'boolean',
       description : 'install the systemd-timedated daemon')
option('timesyncd', type : 'boolean',
       description : 'install the systemd-timesyncd daemon')
option('remote', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'support for "journal over the network"')
option('nss-myhostname', type : 'boolean',
       description : 'install nss-myhostname module')
option('nss-mymachines', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'install nss-mymachines module')
option('nss-resolve', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'install nss-resolve module')
option('nss-systemd', type : 'boolean',
       description : 'install nss-systemd module')
option('firstboot', type : 'boolean',
       description : 'support for firstboot mechanism')
option('randomseed', type : 'boolean',
       description : 'support for restoring random seed')
option('backlight', type : 'boolean',
       description : 'support for restoring backlight state')
option('vconsole', type : 'boolean',
       description : 'support for vconsole configuration')
option('quotacheck', type : 'boolean',
       description : 'support for the quotacheck tools')
option('sysusers', type : 'boolean',
       description : 'support for the sysusers configuration')
option('tmpfiles', type : 'boolean',
       description : 'support for tmpfiles.d')
option('importd', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'install the systemd-importd daemon')
option('hwdb', type : 'boolean',
       description : 'support for the hardware database')
option('rfkill', type : 'boolean',
       description : 'support for the rfkill tools')
option('man', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'build and install man pages')
option('html', type : 'combo', choices : ['auto', 'true', 'false'],
       value : 'false',
       description : 'build and install html pages')

option('certificate-root', type : 'string', value : '/etc/ssl',
       description : 'the prefix for TLS certificates')
option('dbuspolicydir', type : 'string',
       description : 'D-Bus policy directory')
option('dbussessionservicedir', type : 'string',
       description : 'D-Bus session service directory')
option('dbussystemservicedir', type : 'string',
       description : 'D-Bus system service directory')
option('pkgconfigdatadir', type : 'string', value : '',
       description : 'directory for ')
option('pkgconfiglibdir', type : 'string', value : '',
       description : 'directory for ')
option('rpmmacrosdir', type : 'string', value : 'lib/rpm/macros.d',
       description : 'directory for rpm macros ["no" disables]')
option('pamlibdir', type : 'string',
       description : 'directory for PAM modules')
option('pamconfdir', type : 'string',
       description : 'directory for PAM configuration ["no" disables]')
option('docdir', type : 'string',
       description : 'documentation directory')

option('fallback-hostname', type : 'string', value : 'localhost',
       description : 'the hostname used if none configured')
option('compat-gateway-hostname', type : 'boolean', value : 'false',
       description : 'allow "gateway" as the symbolic name for default gateway')
option('default-hierarchy', type : 'combo',
       choices : ['legacy', 'hybrid', 'unified'], value : 'hybrid',
       description : 'default cgroup hierarchy')
option('default-net-naming-scheme', type : 'combo',
       choices : ['latest', 'v238', 'v239', 'v240'],
       description : 'default net.naming-scheme= value')
option('time-epoch', type : 'integer', value : '-1',
       description : 'time epoch for time clients')
option('system-uid-max', type : 'integer', value : '-1',
       description : 'maximum system UID')
option('system-gid-max', type : 'integer', value : '-1',
       description : 'maximum system GID')
option('dynamic-uid-min', type : 'integer', value : 0x0000EF00,
       description : 'minimum dynamic UID')
option('dynamic-uid-max', type : 'integer', value : 0x0000FFEF,
       description : 'maximum dynamic UID')
option('container-uid-base-min', type : 'integer', value : 0x00080000,
       description : 'minimum container UID base')
option('container-uid-base-max', type : 'integer', value : 0x6FFF0000,
       description : 'maximum container UID base')
option('tty-gid', type : 'integer', value : 5,
       description : 'the numeric GID of the "tty" group')
option('users-gid', type : 'integer', value : '-1',
       description : 'the numeric GID of the "users" group')
option('adm-group', type : 'boolean',
       description : 'the ACL for adm group should be added')
option('wheel-group', type : 'boolean',
       description : 'the ACL for wheel group should be added')
option('nobody-user', type : 'string',
       description : 'The name of the nobody user (the one with UID 65534)',
       value : 'nobody')
option('nobody-group', type : 'string',
       description : 'The name of the nobody group (the one with GID 65534)',
       value : 'nobody')
option('dev-kvm-mode', type : 'string', value : '0666',
       description : '/dev/kvm access mode')
option('group-render-mode', type : 'string', value : '0666',
       description : 'Access mode for devices owned by render group (e.g. /dev/dri/renderD*, /dev/kfd).')
option('default-kill-user-processes', type : 'boolean',
       description : 'the default value for KillUserProcesses= setting')
option('gshadow', type : 'boolean',
       description : 'support for shadow group')

option('default-dnssec', type : 'combo',
       description : 'default DNSSEC mode',
       choices : ['yes', 'allow-downgrade', 'no'],
       value : 'allow-downgrade')
option('default-dns-over-tls', type : 'combo',
       description : 'default DNS-over-TLS mode',
       choices : ['opportunistic', 'no'],
       value : 'no')
option('dns-over-tls', type : 'combo', choices : ['auto', 'gnutls', 'openssl', 'true', 'false'],
       description : 'DNS-over-TLS support')
option('dns-servers', type : 'string',
       description : 'space-separated list of default DNS servers',
       value : '8.8.8.8 8.8.4.4 2001:4860:4860::8888 2001:4860:4860::8844')
option('ntp-servers', type : 'string',
       description : 'space-separated list of default NTP servers',
       value : 'time1.google.com time2.google.com time3.google.com time4.google.com')
option('support-url', type : 'string',
       description : 'the support URL to show in catalog entries included in systemd',
       value : 'https://lists.freedesktop.org/mailman/listinfo/systemd-devel')
option('www-target', type : 'string',
       description : 'the address and dir to upload docs too',
       value : 'www.freedesktop.org:/srv/www.freedesktop.org/www/software/systemd')

option('seccomp', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'SECCOMP support')
option('selinux', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'SELinux support')
option('apparmor', type : 'combo', choices : ['auto', 'true', 'false'],
       description : 'AppArmor support')
option('smack', type : 'boolean',
       description : 'SMACK support')
option('smack-run-label', type : 'string',

=== debian/changelog ===
systemd (240-6ubuntu5) disco; urgency=medium

  * systemd-stable: cherrypick many bugfixes from the v240-stable branch.
    Includes many documentation fixes, memory safety (use after free, read
    overruns, etc), networkd wireguard fixes, POSIX ACL fix which is preventing adm
    group from reading journals (LP: #1824342), journal dropping caches
    improvement, fixes regressions in udevadm / machinectl command line parsing.
    Files:
    - debian/patches/Add-missing-dash-to-all-option-in-the-timedatectl-man-pag.patch
    - debian/patches/Add-note-about-transactions-being-genereated-independentl.patch
    - debian/patches/Change-job-mode-of-manager-triggered-restarts-to-JOB_REPL.patch
    - debian/patches/Fix-omission-in-docs.patch
    - debian/patches/Log-the-job-being-merged.patch
    - debian/patches/NEWS-document-deprecation-of-PermissionsStartOnly-in-v240.patch
    - debian/patches/NEWS-retroactively-describe-.include-deprecation.patch
    - debian/patches/Update-systemd-system.conf.xml.patch
    - debian/patches/basic-prioq-add-prioq_peek_item.patch
    - debian/patches/core-Fix-EOPNOTSUPP-emergency-action-error-string.patch
    - debian/patches/core-Fix-return-argument-check-for-parse_emergency_action.patch
    - debian/patches/core-mount-do-not-add-Before-local-fs.target-or-remote-fs.patch
    - debian/patches/core-mount-move-static-function-earlier-in-file.patch
    - debian/patches/curl-util-fix-use-after-free.patch
    - debian/patches/ethtool-Make-sure-advertise-is-actually-set-when-autonego.patch
    - debian/patches/journal-avoid-buffer-overread-when-locale-name-is-too-lon.patch
    - debian/patches/journal-limit-the-number-of-entries-in-the-cache-based-on.patch
    - debian/patches/journald-periodically-drop-cache-for-all-dead-PIDs.patch
    - debian/patches/machinectl-fix-argument-index-in-error-log.patch
    - debian/patches/man-Fix-a-typo-in-systemd.exec.xml.patch
    - debian/patches/man-fix-reference.patch
    - debian/patches/man-fix-volume-num-of-journalctl.patch
    - debian/patches/man-update-DefaultDependency-in-systemd.mount-5.patch
    - debian/patches/netlink-set-maximum-size-of-WGDEVICE_A_IFNAME.patch
    - debian/patches/network-make-Link-and-NetDev-always-have-the-valid-poiter.patch
    - debian/patches/network-unset-Network-manager-when-loading-.network-file-.patch
    - debian/patches/network-wireguard-rename-and-split-set_wireguard_interfac.patch
    - debian/patches/networkd-wait-for-kernel-to-reply-ipv6-peer-address.patch
    - debian/patches/nspawn-ignore-SIGPIPE-for-nspawn-itself.patch
    - debian/patches/pager-improve-english-a-bit.patch
    - debian/patches/pid1-fix-cleanup-of-stale-implicit-deps-based-on-proc-sel.patch
    - debian/patches/procfs-util-expose-functionality-to-query-total-memory.patch
    - debian/patches/pull-fix-invalid-error-check.patch
    - debian/patches/shared-Revert-commit-49fe5c099-in-parts-for-function-pars.patch
    - debian/patches/shared-dissect-image-make-sure-that-we-don-t-truncate-dev.patch
    - debian/patches/test-execute-unset-HOME-before-testing.patch
    - debian/patches/udev-do-logging-before-setting-variables-to-NULL.patch
    - debian/patches/udev-val-may-be-NULL-use-strempty.patch
    - debian/patches/udevadm-info-a-should-enumerate-sysfs-attributes-not-envs.patch
    - debian/patches/udevd-use-worker_free-on-failure-in-worker_new.patch
    - debian/patches/units-make-sure-initrd-cleanup.service-terminates-before-.patch
    - debian/patches/wait-online-do-not-fail-if-we-receive-invalid-messages.patch
    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=2b3db732ba7e5418d45ca42884e8d075189f2724

  * Only test that gdm3 comes up on amd64. Stalls on other arches.
    File: debian/tests/control
    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=97cb13685dfb353045c449ec5d6d1df60f661079

  * tests/storage: make the test more resilient.
    Skip if the scsi_debug module is not available (like on custom kernels). Do not
    fail the tests if removing the module fail, at the end of the test run.
    File: debian/tests/storage
    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=c08dcb1ffe372acd3a21496758a1984ff78dcdd4

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 11 Apr 2019 14:44:08 +0100

systemd (240-6ubuntu4) disco; urgency=medium

  * pam-systemd: use secure_getenv() rather than getenv()
    CVE-2019-3842
    File: debian/patches/pam-systemd-use-secure_getenv-rather-than-getenv.patch
    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=f3291e9e8c3eafd0c8921cb26a0d5ee0fd563b3c

  * core: queue jobs on uninstall to generate PropertiesChanged signal.
    (LP: #1816812)
    File: debian/patches/core-when-we-uninstall-a-job-add-unit-to-dbus-queue.patch
    https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd/commit/?id=241deca98fb9a0f1ba9a6ba781f738fb31a3bd80

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 10 Apr 2019 01:06:03 +0100

systemd (240-6ubuntu3) disco; urgency=medium

  * virt: detect WSL environment as a container (LP: #1816753)
  * debian/control: Update Vcs-{Browser|Git} to Ubuntu's packaging repository
  * debian/gbp.conf: Set tag format to ubuntu/*

 -- Balint Reczey <rbalint@ubuntu.com>  Fri, 22 Mar 2019 18:39:48 +0100

systemd (240-6ubuntu2) disco; urgency=medium

  * d/p/network-remove-routing-policy-rule-from-foreign-rule.patch
  * d/p/network-do-not-remove-rule-when-it-is-requested-by-e.patch
    - Fix RoutingPolicyRule does not apply correctly (LP: #1818282)

 -- Ioanna Alifieraki <ioanna-marial.alifieraki@canonical.com>  Mon, 04 Mar 2019 10:32:19 +0000

systemd (240-6ubuntu1) disco; urgency=medium

  * Release to ubuntu.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 20 Feb 2019 21:41:03 +0100

systemd (240-6) unstable; urgency=high

  * High urgency as this fixes a vulnerability.

  [ Felipe Sateler ]
  * Reenable pristine-tar in gbp.conf.


=== debian/control ===
Source: systemd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian systemd Maintainers <pkg-systemd-maintainers@lists.alioth.debian.org>
Uploaders: Michael Biebl <biebl@debian.org>,
           Marco d'Itri <md@linux.it>,
           Sjoerd Simons <sjoerd@debian.org>,
           Martin Pitt <mpitt@debian.org>,
           Felipe Sateler <fsateler@debian.org>
Standards-Version: 4.2.1
Rules-Requires-Root: no
Vcs-Git: https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd
Vcs-Browser:  https://git.launchpad.net/~ubuntu-core-dev/ubuntu/+source/systemd
Homepage: https://www.freedesktop.org/wiki/Software/systemd
Build-Depends: debhelper (>= 10.4~),
               pkg-config,
               xsltproc,
               docbook-xsl,
               docbook-xml,
               m4,
               meson (>= 0.49),
               gettext,
               gperf,
               gnu-efi [amd64 i386 arm64 armhf],
               libcap-dev (>= 1:2.24-9~),
               libpam0g-dev,
               libapparmor-dev (>= 2.9.0-3+exp2) <!stage1>,
               libidn11-dev <!stage1>,
               libiptc-dev <!stage1>,
               libaudit-dev <!stage1>,
               libdbus-1-dev (>= 1.3.2) <!nocheck>,
               libcryptsetup-dev (>= 2:1.6.0) <!stage1>,
               libselinux1-dev (>= 2.1.9),
               libacl1-dev,
               liblzma-dev,
               liblz4-dev (>= 0.0~r125),
               liblz4-tool <!nocheck>,
               libbz2-dev <!stage1>,
               zlib1g-dev <!stage1> | libz-dev <!stage1>,
               libcurl4-gnutls-dev <!stage1> | libcurl-dev <!stage1>,
               libmicrohttpd-dev <!stage1>,
               libgnutls28-dev <!stage1>,
               libgcrypt20-dev,
               libkmod-dev (>= 15),
               libblkid-dev (>= 2.24),
               libmount-dev (>= 2.30),
               libseccomp-dev (>= 2.3.1) [amd64 arm64 armel armhf i386 mips mipsel mips64 mips64el x32 powerpc ppc64 ppc64el s390x],
               libdw-dev (>= 0.158) <!stage1>,
               libpolkit-gobject-1-dev <!stage1>,
               linux-base <!nocheck>,
               acl <!nocheck>,
               python3:native,
               python3-lxml:native,
               python3-pyparsing <!nocheck>,
               python3-evdev <!nocheck>,
               tzdata <!nocheck>,
               libcap2-bin <!nocheck>,
               iproute2 <!nocheck>,

Package: systemd
Architecture: linux-any
Multi-Arch: foreign
Section: admin
Priority: important
Recommends: libpam-systemd,
            dbus,
            networkd-dispatcher
Suggests: systemd-container,
          policykit-1
Pre-Depends: ${shlibs:Pre-Depends},
             ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsystemd0 (= ${binary:Version}),
         util-linux (>= 2.27.1),
         mount (>= 2.26),
         adduser,
Conflicts: consolekit,
           systemd-shim, upstart,
           libpam-ck-connector,
Breaks: apparmor (<< 2.9.2-1),
        ifupdown (<< 0.8.5~),
        udev (<< 228-5),
        laptop-mode-tools (<< 1.68~),
        python-dbusmock (<< 0.18),
        python3-dbusmock (<< 0.18),
Replaces: udev (<< 228-5),
Description: system and service manager
 systemd is a system and service manager for Linux. It provides aggressive
 parallelization capabilities, uses socket and D-Bus activation for starting
 services, offers on-demand starting of daemons, keeps track of processes using
 Linux control groups, maintains mount and automount points and implements an
 elaborate transactional dependency-based service control logic.
 .
 systemd is compatible with SysV and LSB init scripts and can work as a
 drop-in replacement for sysvinit.
 .
 Installing the systemd package will not switch your init system unless you
 boot with init=/bin/systemd or install systemd-sysv in addition.

Package: systemd-sysv
Architecture: linux-any
Multi-Arch: foreign
Section: admin
Priority: important
Conflicts: sysvinit-core,
           upstart (<< 1.13.2-0ubuntu10~),
           upstart-sysv,
           openrc (<< 0.20.4-2.1),
           file-rc,
           systemd-shim,
Replaces: sysvinit-core,
          upstart (<< 1.13.2-0ubuntu10~),
          upstart-sysv,
Pre-Depends: systemd
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd (= ${binary:Version}),
Recommends: libnss-systemd
Description: system and service manager - SysV links
 systemd is a system and service manager for Linux. It provides aggressive
 parallelization capabilities, uses socket and D-Bus activation for starting
 services, offers on-demand starting of daemons, keeps track of processes using
 Linux control groups, maintains mount and automount points and implements an
 elaborate transactional dependency-based service control logic.
 .
 systemd is compatible with SysV and LSB init scripts and can work as a
 drop-in replacement for sysvinit.
 .
 This package provides the manual pages and links needed for systemd
 to replace sysvinit. Installing systemd-sysv will overwrite /sbin/init with a
 link to systemd.

Package: systemd-container
Build-Profiles: <!stage1>
Architecture: linux-any
Multi-Arch: foreign
Section: admin
Priority: optional
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd,
         dbus
Recommends: btrfs-progs,
            libnss-mymachines,
Breaks: systemd (<< 224-2)
Replaces: systemd (<< 224-2)
Description: systemd container/nspawn tools
 This package provides systemd's tools for nspawn and container/VM management:
  * systemd-nspawn
  * systemd-machined and machinectl
  * systemd-importd

Package: systemd-journal-remote
Build-Profiles: <!stage1>
Architecture: linux-any
Multi-Arch: foreign
Section: admin
Priority: optional
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd,
         adduser
Breaks: systemd (<< 239-6)
Replaces: systemd (<< 239-6)
Description: tools for sending and receiving remote journal logs
 This package provides tools for sending and receiving remote journal logs:
  * systemd-journal-remote
  * systemd-journal-upload
  * systemd-journal-gatewayd

Package: systemd-coredump
Build-Profiles: <!stage1>
Architecture: linux-any
Multi-Arch: foreign
Section: admin
Priority: optional
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser,
         systemd
Conflicts: core-dump-handler
Replaces: core-dump-handler, systemd (<< 229-2)
Provides: core-dump-handler
Breaks: systemd (<< 229-2)
Description: tools for storing and retrieving coredumps
 This package provides systemd tools for storing and retrieving coredumps:
  * systemd-coredump
  * coredumpctl

Package: systemd-tests
Architecture: linux-any
Section: admin
Priority: optional
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd (= ${binary:Version}),
         python3,
Description: tests for systemd
 This package contains the test binaries. Those binaries are primarily used
 for autopkgtest and not meant to be installed on regular user systems.

Package: libpam-systemd
Architecture: linux-any
Multi-Arch: same
Section: admin
Priority: standard
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd (= ${binary:Version}),
         libpam-runtime (>= 1.0.1-6),
         dbus,
         systemd-sysv
Description: system and service manager - PAM module
 This package contains the PAM module which registers user sessions in
 the systemd control group hierarchy for logind.
 .
 If in doubt, do install this package.
 .
 Packages that depend on logind functionality need to depend on libpam-systemd.

Package: libnss-myhostname
Architecture: linux-any
Multi-Arch: same
Section: admin
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
Breaks: systemd (<< 222-1)
Replaces: systemd (<< 222-1)
Description: nss module providing fallback resolution for the current hostname
 This package contains a plugin for the Name Service Switch, providing host
 name resolution for the locally configured system hostname as returned by
 gethostname(2). It returns all locally configured public IP addresses or -- if
 none are configured, the IPv4 address 127.0.1.1 (which is on the local
 loopback) and the IPv6 address ::1 (which is the local host).
 .
 A lot of software relies on that the local host name is resolvable. This
 package provides an alternative to the fragile and error-prone manual editing
 of /etc/hosts.
 .
 Installing this package automatically adds myhostname to /etc/nsswitch.conf.

Package: libnss-mymachines
Architecture: linux-any
Multi-Arch: same
Section: admin
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd-container (= ${binary:Version}),
Breaks: systemd (<< 222-1)
Replaces: systemd (<< 222-1)
Description: nss module to resolve hostnames for local container instances
 nss-mymachines is a plugin for the GNU Name Service Switch (NSS) functionality
 of the GNU C Library (glibc) providing hostname resolution for local containers
 that are registered with systemd-machined.service(8). The container names are
 resolved to IP addresses of the specific container, ordered by their scope.
 .
 Installing this package automatically adds mymachines to /etc/nsswitch.conf.

Package: libnss-resolve
Architecture: linux-any
Multi-Arch: same
Section: admin
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd (= ${binary:Version}),
Breaks: systemd (<< 227-3)
Replaces: systemd (<< 227-3)
Description: nss module to resolve names via systemd-resolved
 nss-resolve is a plugin for the GNU Name Service Switch (NSS) functionality
 of the GNU C Library (glibc) providing DNS and LLMNR resolution to programs via
 the systemd-resolved daemon (provided in the systemd package).
 .
 Installing this package automatically adds resolve to /etc/nsswitch.conf.

Package: libnss-systemd
Architecture: linux-any
Multi-Arch: same
Section: admin
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         systemd (= ${binary:Version}),
Description: nss module providing dynamic user and group name resolution
 nss-systemd is a plug-in module for the GNU Name Service Switch (NSS)
 functionality of the GNU C Library (glibc), providing UNIX user and group name
 resolution for dynamic users and groups allocated through the DynamicUser=
 option in systemd unit files. See systemd.exec(5) for details on this
 option.
 .
 Installing this package automatically adds the module to /etc/nsswitch.conf.

Package: libsystemd0
Architecture: linux-any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${shlibs:Depends},
             ${misc:Pre-Depends}
Depends: ${misc:Depends}
Description: systemd utility library
 The libsystemd0 library provides interfaces to various systemd components.

Package: libsystemd-dev
Architecture: linux-any
Multi-Arch: same
Section: libdevel
Priority: optional
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libsystemd0 (= ${binary:Version})
Description: systemd utility library - development files
 The libsystemd0 library provides interfaces to various systemd components.
 .
 This package contains the development files.

Package: udev
Section: admin
Priority: important
Architecture: linux-any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         adduser,
         libudev1 (= ${binary:Version}),
         lsb-base (>= 3.0-6),
         util-linux (>= 2.27.1),
         s390-tools (>> 1.6.2) [s390],
Conflicts: hal
Breaks: systemd (<< 233-4),
        ifupdown (<< 0.8.5~),
        ifplugd (<< 0.28-19.1~),
        joystick (<< 1:1.4.9-1~),
Replaces: systemd (<< 233-4)
Description: /dev/ and hotplug management daemon

=== debian/rules ===
#! /usr/bin/make -f

#export DH_VERBOSE = 1
#export DEB_BUILD_OPTIONS = nostrip

export LC_ALL = C.UTF-8

include /usr/share/dpkg/default.mk

ifeq ($(DEB_VENDOR),Ubuntu)
    DEFAULT_NTP_SERVERS = ntp.ubuntu.com
    SUPPORT_URL = http://www.ubuntu.com/support
    CONFFLAGS_DISTRO = -Ddns-servers=''
else
    DEFAULT_NTP_SERVERS = 0.debian.pool.ntp.org 1.debian.pool.ntp.org 2.debian.pool.ntp.org 3.debian.pool.ntp.org
    SUPPORT_URL = https://www.debian.org/support
    CONFFLAGS_DISTRO =
endif

ifneq (, $(filter $(DEB_BUILD_ARCH), riscv64))
    TEST_TIMEOUT_MULTIPLIER = "-t 10"
endif

# fail on missing files and symbols changes on distro builds, but not if we
# build/test upstream master
ifeq ($(TEST_UPSTREAM),)
    DH_MISSING = --fail-missing
    GENSYMBOLS_LEVEL = 4
else
    DH_MISSING = --list-missing
    GENSYMBOLS_LEVEL = 1
endif

ifneq (, $(filter noudeb, $(DEB_BUILD_OPTIONS)))
export DEB_BUILD_PROFILES += noudeb
endif

CONFFLAGS = \
	-Db_lto=true \
	-Db_pie=true \
	-Drootlibdir=/lib/$(DEB_HOST_MULTIARCH) \
	-Dsplit-usr=true \
	-Dquotaon-path=/sbin/quotaon \
	-Dquotacheck-path=/sbin/quotacheck \
	-Dkmod-path=/bin/kmod \
	-Dkexec-path=/sbin/kexec \
	-Dsulogin-path=/sbin/sulogin \
	-Dmount-path=/bin/mount \
	-Dumount-path=/bin/umount \
	-Dloadkeys-path=/bin/loadkeys \
	-Dsetfont-path=/bin/setfont \
	-Dtelinit-path=/lib/sysvinit/telinit \
	-Dsysvinit-path=/etc/init.d \
	-Dsysvrcnd-path=/etc \
	-Ddebug-shell=/bin/bash \
	-Dzshcompletiondir=/usr/share/zsh/vendor-completions \
	-Ddbuspolicydir=/usr/share/dbus-1/system.d/ \
	-Dsupport-url=$(SUPPORT_URL) \
	-Ddefault-kill-user-processes=false \
	-Dpamconfdir=no \
	-Drpmmacrosdir=no \
	-Dqrencode=false \
	-Dvconsole=false \
	-Dfirstboot=false \
	-Dxkbcommon=false \
	-Dportabled=false \
	-Dwheel-group=false \
	-Dntp-servers="$(DEFAULT_NTP_SERVERS)" \
	-Dlink-udev-shared=false \
	-Dsystem-uid-max=999 \
	-Dsystem-gid-max=999 \
	-Dnobody-user=nobody \
	-Dnobody-group=nogroup \
	-Dbump-proc-sys-fs-nr-open=false \
	-Ddev-kvm-mode=0660

# resolved's DNSSEC support is still not mature enough, don't enable it by
# default on stable Debian or any Ubuntu releases
CONFFLAGS += $(shell grep -qE 'stretch|ubuntu' /etc/os-release && echo -Ddefault-dnssec=no)

CONFFLAGS_deb = \
	-Dselinux=true \
	-Dhwdb=true \
	-Dsysusers=true \
	-Dinstall-tests=true \
	-Defi=true \
	-Dnss-myhostname=true \
	-Dnss-mymachines=true \
	-Dnss-resolve=true \
	-Dnss-systemd=true \
	-Dresolve=true \
	-Dlink-systemctl-shared=false

ifeq (, $(filter stage1, $(DEB_BUILD_PROFILES)))
CONFFLAGS_deb += \
	-Daudit=true \
	-Dlibcryptsetup=true \
	-Dcoredump=true \
	-Delfutils=true \
	-Dapparmor=true \
	-Dlibidn=true \
	-Dlibiptc=true \
	-Dlibcurl=true \
	-Dimportd=true \
	-Dmicrohttpd=true \
	-Dgnutls=true
else
CONFFLAGS_deb += \
	-Daudit=false \
	-Dlibcryptsetup=false \
	-Dcoredump=false \
	-Delfutils=false \
	-Dapparmor=false \
	-Dlibidn=false \
	-Dlibiptc=false \
	-Dlibcurl=false \
	-Dimportd=false \
	-Dmicrohttpd=false \
	-Dgnutls=false
endif

CONFFLAGS_udeb = \
	-Dlibcryptsetup=false \
	-Dcoredump=false \
	-Delfutils=false \
	-Dpam=false \
	-Daudit=false \
	-Dselinux=false\
	-Dapparmor=false \
	-Dlibidn=false \
	-Dlibiptc=false \
	-Dsmack=false \
	-Dima=false \
	-Dbinfmt=false \
	-Dquotacheck=false \
	-Dtmpfiles=false \
	-Drandomseed=false \
	-Dbacklight=false \
	-Dlogind=false \
	-Dmachined=false \
	-Dlibcurl=false \
	-Dimportd=false \
	-Dmicrohttpd=false \
	-Dgnutls=false \
	-Dhostnamed=false \
	-Dtimedated=false \
	-Dnetworkd=false \
	-Dtimesyncd=false \
	-Dlocaled=false \
	-Dnss-myhostname=false \
	-Dnss-mymachines=false \
	-Dnss-resolve=false \
	-Dnss-systemd=false \
	-Dresolve=false \
	-Dpolkit=false \
	-Dacl=false \
	-Dgcrypt=false \
	-Drfkill=false \
	-Dhwdb=false \
	-Dman=false \
	-Defi=false \
	-Dseccomp=false \
	-Dsysusers=false

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build-deb \
		-- $(CONFFLAGS) $(CONFFLAGS_DISTRO) $(CONFFLAGS_deb)
ifeq (, $(filter noudeb, $(DEB_BUILD_PROFILES)))
	dh_auto_configure --builddirectory=build-udeb \
		-- $(CONFFLAGS) $(CONFFLAGS_DISTRO) $(CONFFLAGS_udeb)
endif

override_dh_auto_build:
	dh_auto_build --builddirectory=build-deb
ifeq (, $(filter noudeb, $(DEB_BUILD_PROFILES)))
	dh_auto_build --builddirectory=build-udeb
endif
	# generate POT file for translators
	ninja -C build-deb/ systemd-pot

override_dh_auto_install:
	dh_auto_install --builddirectory=build-deb \
		--destdir=debian/install/deb
ifeq (, $(filter noudeb, $(DEB_BUILD_PROFILES)))
	dh_auto_install --builddirectory=build-udeb \
		--destdir=debian/install/udeb
endif
	# fix paths in manpages; manually check the remaining /usr occurrences
	# occasionally, with filtering out paths which are known to be in /usr:
	# grep -r /usr debian/install/deb/usr/share/man/|egrep -v '/usr/local|os.*release|factory|zoneinfo|tmpfiles|kernel|foo|machines|sysctl|dbus|include|binfmt'
	find debian/install/deb/usr/share/man/ -type f | xargs sed -ri 's_/usr(/lib/systemd/system|/lib/systemd/network|/lib/udev|/lib[^/]|/lib/[^a-z])_\1_g'

override_dh_auto_clean:
ifneq (, $(TEST_UPSTREAM))
	debian/extra/checkout-upstream
endif
	dh_auto_clean --builddirectory=build-deb
ifeq (, $(filter noudeb, $(DEB_BUILD_PROFILES)))
	dh_auto_clean --builddirectory=build-udeb
endif
	rm -rf debian/install/ debian/shlibs.local
	# remove Python byte code files
	rm -rf tools/__pycache__/
	rm -f po/systemd.pot

override_dh_install:
	# remove unnecessary / unused files
	rm -f debian/install/*/usr/share/doc/systemd/LICENSE.*
	rm -f debian/install/*/var/log/README
	rm -f debian/install/*/etc/init.d/README
	rm -f debian/install/*/etc/X11/xinit/xinitrc.d/50-systemd-user.sh
	rmdir -p --ignore-fail-on-non-empty debian/install/*/etc/X11/xinit/xinitrc.d/
	rm -f debian/install/*/lib/systemd/system/halt-local.service
	# remove files related to factory-reset feature
	find debian/install/ \( -name 'systemd-update-done*' -o \
		-name systemd-journal-catalog-update.service -o \
		-name systemd-udev-hwdb-update.service -o \
		-name ldconfig.service -o \
		-name etc.conf \) -delete
	rm -rf debian/install/*/usr/share/factory/
	# remove symlinks enabling default-on services
	rm -rf debian/install/*/etc/systemd/system/*.target.wants/
	# remove aliases
	find debian/install/*/etc/systemd/system/ -type l -delete
	# replace upstream sysusers.d/basic.conf with proper users for Debian
	debian/extra/make-sysusers-basic > debian/install/deb/usr/lib/sysusers.d/basic.conf
	# remove resolvconf compat symlink
	rm -f debian/install/*/sbin/resolvconf
ifeq (, $(filter noudeb, $(DEB_BUILD_PROFILES)))
	dh_install -pudev-udeb -plibudev1-udeb --sourcedir=debian/install/udeb
endif

	dh_install --remaining-packages --sourcedir=debian/install/deb

	# we don't want /tmp to be a tmpfs by default
	mv debian/systemd/lib/systemd/system/tmp.mount debian/systemd/usr/share/systemd/
	printf '\n[Install]\nWantedBy=local-fs.target\n' >> debian/systemd/usr/share/systemd/tmp.mount
	rm debian/systemd/lib/systemd/system/local-fs.target.wants/tmp.mount

	# files shipped by cryptsetup
ifeq (, $(filter stage1, $(DEB_BUILD_PROFILES)))
	rm debian/systemd/usr/share/man/man5/crypttab.5
endif

	# files shipped by systemd
	rm debian/udev/lib/udev/rules.d/70-uaccess.rules
	rm debian/udev/lib/udev/rules.d/73-seat-late.rules
	rm debian/udev/lib/udev/rules.d/71-seat.rules
	rm debian/udev/lib/udev/rules.d/99-systemd.rules

	# remove duplicate files shipped by systemd-*/udev
	echo "Removing duplicate files in systemd package:"
	set -e; for pkg in $(shell dh_listpackages -Nudev-udeb -Nlibudev1-udeb -Nsystemd); do \
		echo "... from $$pkg..."; \
		(cd debian/$$pkg; find -type f -o -type l) | (cd debian/systemd; xargs rm -f --verbose); \
		(cd debian/$$pkg; find -mindepth 1 -type d) | (cd debian/systemd; xargs rmdir --ignore-fail-on-non-empty --verbose || true); \
	done

	# Ubuntu specific files
ifeq ($(DEB_VENDOR),Ubuntu)
	install -D --mode=644 debian/extra/udev.py debian/udev/usr/share/apport/package-hooks/udev.py

=== debian/tests/control ===
Tests: timedated, hostnamed, localed-locale, localed-x11-keymap
Depends: systemd,
  udev,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
Restrictions: needs-root, isolation-container

Tests: logind
Depends: systemd,
  udev,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
Restrictions: needs-root, isolation-container

Tests: unit-config
Depends: systemd,
  udev,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkg-config,
Restrictions: needs-root, allow-stderr

Tests: storage
Depends: systemd,
  udev,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkg-config,
  cryptsetup-bin,
Restrictions: needs-root, isolation-machine

Tests: networkd-test.py
Tests-Directory: test
Depends: systemd,
  udev,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkg-config,
  cryptsetup-bin,
  systemd-sysv,
  policykit-1,
  dnsmasq-base
Restrictions: needs-root, isolation-container

Tests: build-login
Depends: systemd,
  udev,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkg-config,
  cryptsetup-bin,
  systemd-sysv,
  policykit-1,
  dnsmasq-base,
  build-essential,
  libsystemd-dev,
Restrictions: isolation-container

Tests: boot-and-services
Depends: systemd-sysv,
  systemd,
  udev,
  systemd-container,
  systemd-coredump,
  libpam-systemd,
  xserver-xorg-video-dummy,
  xserver-xorg,
  gdm3 [amd64],
  cron,
  network-manager,
  busybox-static,
  apparmor,
  pkg-config,
  python3
Restrictions: needs-root, isolation-machine, breaks-testbed

Tests: udev
Depends: systemd-tests,
  udev,
  python3,
  tree,
  perl,
  xz-utils,
Restrictions: needs-root, allow-stderr, isolation-machine

Tests: root-unittests
Depends: systemd-tests,
  udev,
  libpam-systemd,
  tree,
  perl,
  xz-utils,
  libcap2-bin,
  iproute2,
  liblz4-tool,
  acl,
  iputils-ping,
  dbus-user-session,
Restrictions: needs-root, allow-stderr, isolation-container

Tests: upstream
Depends: libsystemd-dev,
  tree,
  perl,
  xz-utils,
  libcap2-bin,
  iproute2,
  liblz4-tool,
  acl,
  kbd,
  cryptsetup-bin,
  net-tools,
  isc-dhcp-client,
  iputils-ping,
  strace,
  qemu-system-x86 [amd64 i386],
  qemu-system-arm [arm64 armhf],
  qemu-system-s390x [s390x],
  qemu-system-ppc [ppc64el],
  less,
  pkg-config,
  gcc,
  libc6-dev | libc-dev,
  make,
  quota,
  systemd-journal-remote,
  systemd-container,
  systemd-coredump,
  fdisk | util-linux (<< 2.29.2-3~),
  netcat-openbsd,
  socat,
  busybox-static,
  plymouth,
  e2fsprogs,
Restrictions: needs-root, allow-stderr, isolation-machine

Tests: boot-smoke
Depends: libsystemd-dev,
  tree,
  perl,
  xz-utils,
  libcap2-bin,
  iproute2,
  liblz4-tool,
  acl,
  kbd,
  cryptsetup-bin,
  net-tools,
  isc-dhcp-client,
  iputils-ping,
  strace,
  qemu-system-x86 [amd64 i386],
  qemu-system-arm [arm64 armhf],
  qemu-system-s390x [s390x],
  less,
  pkg-config,
  gcc,
  libc6-dev | libc-dev,
  make,
  quota,
